# class Psych::TreeBuilder

This class works in conjunction with Psych::Parser to build an in-memory parse tree that represents a YAML document.

## Example¶ ↑

    parser = Psych::Parser.new Psych::TreeBuilder.new
    parser.parse('--- foo')
    tree = parser.handler.root

See Psych::Handler for documentation on the event methods used in this class.

### Attributes

root[R]

Returns the root node for the built tree

### Public Class Methods

new() click to toggle source

Create a new TreeBuilder instance

    # File lib/psych/tree_builder.rb, line 22
    def initialize
      @stack = []
      @last  = nil
      @root  = nil
    end

### Public Instance Methods

alias(anchor) click to toggle source

    # File lib/psych/tree_builder.rb, line 81
    def alias anchor
      @last.children << Nodes::Alias.new(anchor)
    end

end_document(implicit_end = !streaming?) click to toggle source

Handles #end_document events with `version`, `tag_directives`, and `implicit` styling.

See Psych::Handler#start_document

    # File lib/psych/tree_builder.rb, line 61
    def end_document implicit_end = !streaming?
      @last.implicit_end = implicit_end
      pop
    end

end_stream() click to toggle source

    # File lib/psych/tree_builder.rb, line 71
    def end_stream
      pop
    end

scalar(value, anchor, tag, plain, quoted, style) click to toggle source

    # File lib/psych/tree_builder.rb, line 75
    def scalar value, anchor, tag, plain, quoted, style
      s = Nodes::Scalar.new(value,anchor,tag,plain,quoted,style)
      @last.children << s
      s
    end

start_document(version, tag_directives, implicit) click to toggle source

Handles #start_document events with `version`, `tag_directives`, and `implicit` styling.

See Psych::Handler#start_document

    # File lib/psych/tree_builder.rb, line 50
    def start_document version, tag_directives, implicit
      n = Nodes::Document.new version, tag_directives, implicit
      @last.children << n
      push n
    end

start_stream(encoding) click to toggle source

    # File lib/psych/tree_builder.rb, line 66
    def start_stream encoding
      @root = Nodes::Stream.new(encoding)
      push @root
    end

### Private Instance Methods

pop() click to toggle source

    # File lib/psych/tree_builder.rb, line 91
    def pop
      x = @stack.pop
      @last = @stack.last
      x
    end

push(value) click to toggle source

    # File lib/psych/tree_builder.rb, line 86
    def push value
      @stack.push value
      @last = value
    end